import { drawerManager as DrawerManager } from "./drawer-manager";
import { app as App } from "../../app";
import { stageManager as StageManger } from "../application/stage-manager";

export class Drawer {
  constructor() {
    this.component;
    this.drawerManager = DrawerManager;
    this.drawing = false;
    this.states = [];
    this.state = undefined;
    this.konvaObject;
    this.elementClass = undefined;
  }
  onDragMove() { }
  setElementClass(elementClass) {
    this.elementClass = elementClass;
  }
  setState(state) {
    this.state = state;
  }
  clearState() {
    this.state = undefined;
  }
  setStatus(status) {
    App.setStatus(status);
  }
  clear() {
    this.clearState();
    App.clearSelectedTool();
    this.setStatus("");
  }
  addAggregator(aggregator) {
    DrawerManager.addAggregator(aggregator);
  }
  draw(object) {
    Drawer.drawObject(object);
  }
  batchDraw() {
    Drawer.stageBatchDraw();
  }
  update(aggregator, event) {
    throw "Not implemented exception";
  }
  setKonvaObject(konvaObject) {
    this.konvaObject = konvaObject;
  }
  static drawObject(object) {
    DrawerManager.draw(object);
  }
  static getKonvaGroup(draggable) {
    if (draggable == undefined) draggable = true;
    const group = new Konva.Group({
      draggable: draggable,
      resizeEnabled: false
    });
    return group;
  }
  static stageBatchDraw() {
    DrawerManager.batchDraw();
  }
}
